<?php

/**
 *                              
 *                                                             
 *                                                                               
 */
function build_url($parsed) {
$url = '';
if (isset($parsed['scheme'])) {
$url .= $parsed['scheme'] . '://';
}
if (isset($parsed['user'])) {
$url .= $parsed['user'];
}
if (isset($parsed['pass'])) {
$url .= ':' . $parsed['pass'];
}
if (isset($parsed['user']) || isset($parsed['pass'])) {
$url .= '@';
}
if (isset($parsed['host'])) {
$url .= $parsed['host'];
}
if (isset($parsed['port'])) {
$url .= ':' . $parsed['port'];
}
if (isset($parsed['path'])) {
$url .= $parsed['path'];
}
if (isset($parsed['query'])) {
$url .= '?' . $parsed['query'];
}
if (isset($parsed['fragment'])) {
$url .= '#' . $parsed['fragment'];
}
return $url;
}

/**
 *                                                    
 *                                
 *                                       
 *                                         
 */
function url_merge_params($url, $redefine) {
$parsed = parse_url($url);
$params = array();
parse_str($parsed["query"], $params);
foreach ($redefine as $key => $value) {
$params[$key] = $value;
}
$parsed["query"] = http_build_query($params);
return build_url($parsed);
}

/**
 *                                      
 */
function test_build_url() {
foreach (array('https://gentics.com:443/one?two=three#four',
'gentics.com:443/one?two=three#four',
'/one?two=three#four',
'http://user:pass@gentics.com:8080/one?two=three#four',
)
as $url)
{
$rebuilt = build_url(parse_url($url));
if ($rebuilt != $url) {
die("error in " . __FUNCTION__ . ": $rebuilt <> $url\n");
}
}
}

/**
 *                                             
 */
function test_url_merge_params() {
foreach (array('gentics.com/one?two=three#four' => 'gentics.com/one?two=three&four=five#four',
'gentics.com/one?#four' => 'gentics.com/one?four=five#four',
'gentics.com?two=three&four=x&five=six' => 'gentics.com?two=three&four=five&five=six',
)
as $original => $with_added_params)
{
$merged = url_merge_params($original, array('four' => 'five', 'six' => null));
if ($merged != $with_added_params) {
die("error in " . __FUNCTION__ . ": $merged <> $with_added_params\n");
}
}
}

//   
