<?

function tree_xnlproperty_browser( $id ) {

global $xnlFunctionPackages, $T_XNLPACKAGE, $T_XNLFUNCTION;

$packs = $xnlFunctionPackages["hash"];
$pkg = ($id)?explode(".",$id):array();
foreach ($pkg as $key=>$pack) {
$packs = $packs[$pack];
}

$arr = array();
foreach ($packs as $package=>$val) {
$key = $id . ($id?".":""). $package;
$pack = $xnlFunctionPackages["pack"][$key];
$rs = array();
$rs["id"] = $key;
$rs["name"] = $pack["name"]?$pack["name"]:$package;
$rs["type"] = $T_XNLPACKAGE;
$arr[] = $rs;
}
if ($id) {
foreach ($xnlFunctionPackages["func"][$id] as $function=>$func) {
$rs = array();
$rs["id"] = $id.".".$function;
$rs["name"] = $func["name"]?$func["name"]:$function;
$rs["type"] = $T_XNLFUNCTION;
$arr[] = $rs;
}
}

return $arr;
}

class XNLFunctionComponent extends SelectableFormComponent {

var $d_packages;
var $d_selected;
var $d_function;

function XNLFunctionComponent() {
parent::FormComponent();
$this->d_packages = array();
$this->d_values["selectedFunc"] = "";
$this->d_selected = false;
$this->_rehashPackages();
}

function reset() {
$this->d_function = "";
$this->d_selected = false;
}

function setFunction($func) {
$this->d_function = $func;
$this->d_selected = true;
}

function getFunction() {
return $this->d_function;
}

function getSerializeKey() {
$rs["parent"] = parent::getSerializeKey();
$rs["packages"] = $this->d_packages;
$rs["selected"] = $this->d_selected;
$rs["function"] = $this->d_function;
return $rs;
}

function initFromSerializeKey( $key ) {
parent::initFromSerializeKey( $key["parent"] );
$this->d_packages = $key["packages"];
$this->d_selected = $key["selected"];
$this->d_function = $key["function"];
}

function &getResultObject() {
if (!$this->d_selected) return new NodeException("XNLFunction: Function not yet selected.");
return new StringObject($this->d_function);
}

function setObject(&$obj) {
$this->setFunction($obj->toString());
}

function getFields() {
return array_merge( parent::getFields(), array("selectedFunc"=>i18n("Selected Function")));
}

function onLoadFinished() {
if ($this->d_values["selectedFunc"]) {
$this->setFunction($this->d_values["selectedFunc"]);
$this->selectionFinished();
$this->d_values["selectedFunc"] = "";
}
}

function getHTML( &$form, $prefix, $doCheck, $checkSeverity, $key ) {

global $STAG, $DO, $T_XNLPACKAGE, $T_XNLFUNCTION, $ICO_XNLPACKAGE, $ICO_XNLFUNCTION;

node_include("tree");
node_include("i18n");

$t = new tree(array());
$t->openvar = $prefix."_openvar";
$t->showasform = true;
$t->treelink = "$STAG&do=$DO";
$t->linksubmit = $form->getFormName();
$t->linksubmitaction = $form->getNoncheckingJsSubmitCall();

$t->type = array();
$t->type[$T_XNLPACKAGE]["name"] = i18n("XNL Package");
$t->type[$T_XNLPACKAGE]["object"] = false;
$t->type[$T_XNLPACKAGE]["self_fkt"] = "\"\$nid\"";
$t->type[$T_XNLPACKAGE]["fkt"] = "tree_xnlproperty_browser( \\\"\$nid\\\" )";
$t->type[$T_XNLPACKAGE]["ntype"] = "type";
$t->type[$T_XNLPACKAGE]["nid"] = "id";
$t->type[$T_XNLPACKAGE]["nname"] = "name";
$t->type[$T_XNLPACKAGE]["allowlink"] = false;
$t->type[$T_XNLPACKAGE]["folderopen"] = $ICO_XNLPACKAGE;
$t->type[$T_XNLPACKAGE]["folderclosed"] = $ICO_XNLPACKAGE;
$t->type[$T_XNLFUNCTION]["name"] = i18n("XNL Function");
$t->type[$T_XNLFUNCTION]["object"] = false;
$t->type[$T_XNLFUNCTION]["self_fkt"] = "\"\$nid\"";
$t->type[$T_XNLFUNCTION]["allowlink"] = true;
$t->type[$T_XNLFUNCTION]["linkvar"] = $prefix."selectedFunc";
$t->type[$T_XNLFUNCTION]["linktarget"] = "_self";
$t->type[$T_XNLFUNCTION]["folderopen"] = $ICO_XNLFUNCTION;
$t->type[$T_XNLFUNCTION]["folderclosed"] = $ICO_XNLFUNCTION;

global $xnlFunctionPackages;
$xnlFunctionPackages = $this->d_packages;

$html = "<table><tr valign=top><td>";
$html .= $t->walktree("", false, 0, $T_XNLPACKAGE);
$html .= "</td><td width=15>&nbsp;&nbsp;</td><td>";

if ($this->d_function) {
//                                                                           
 $html .= "<p><b>".$this->d_function."</b></p>";
$html .= $this->_getFunctionDescription($this->d_function);
}

$html .= "</td></tr></table>";

return $this->mergeResult( parent::getHTML( $form, $prefix, $doCheck, $checkSeverity, $key ), $html );
}

function toString() {
return $this->d_function;
}

function isFinished() {
return ($this->d_selected);
}

function _rehashPackages() {
global $XNL_FUNCTION;
node_include("xnlloader");

$xnlloader = new XNLLoader($XNL_FUNCTION);
$xnlloader->fetchPackages();

$packages = $xnlloader->getPackages();
$this->d_packages["hash"] = array();
foreach ($packages as $package=>$val) {
$pkg = explode(".",$package);

$a =& $this->d_packages["hash"];
foreach ($pkg as $key=>$pack) {
if (!isset($a[$pack])) $a[$pack] = array();
unset($tmp);$tmp=&$a[$pack];
unset($a); $a=&$tmp;
}
$this->d_packages["pack"][$package] = $xnlloader->getPackage($package);
$this->d_packages["func"][$package] = $xnlloader->getFunctions($package);
}
}

function _getFunctionDescription($function) {
$html = "";

$pkg = substr($function, 0, strrpos($function, "."));
$fkt = substr($function, strpos($function, ".") + 1);
$func = $this->d_packages["func"][$pkg][$fkt];

$html .= "<i>".i18n("Name").":</i> ".$func["name"]."<br>\n";
$html .= "<i>".i18n("Description").":</i> ".$func["description"]."<br>\n";
$html .= "<i>".i18n("Cache").":</i> ";
if ($func["cache"]["allowcache"]) {
$html .= i18n("Yes");
if ($func["cache"]["interval"]) $html .= ", ".i18n("every {0} minutes",0,$func["cache"]["interval"]);
} else {
$html .= i18n("No");
}
$html .= "<br><br>";
$html .= "<b><i>".i18n("Parameters")."</i></b><br>";
$html .= "<table border=0 cellpadding=2 cellspacing=2>";
foreach ($func["params"] as $param=>$val) {
$html .= "<tr valign=top><td><i>$param</i></td><td>";
if ($val["default"] !== false) $html .= "<i>".i18n("Default").":</i> ".$val["default"]."<br>";
$html .= "<i>".i18n("Optional").":</i> ".($val["optional"]?i18n("Yes"):i18n("No"))."<br>";
if ($val["description"]) $html .= $val["description"]."<br>";
$html .= "</td></tr>";
}
$html .= "</table>";

return $html;
}
}

?>
