<?php
/**
 *                                                                       
 *                                                                                    
 *                                                                                            
 *                                              
 *
 *       
 *                    
 *                            
 *                          
 */
GUIFactory::setMainGUI( "shell" );
header("Content-Type: text/xml");

switch ($SPELLCHECK_METHOD) {
//                             
case "google";
$data = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>
<spellrequest textalreadyclipped=\"0\" ignoredups=\"0\" ignoredigits=\"1\" ignoreallcaps=\"1\">
	<text><![CDATA[$string]]></text>
</spellrequest>";  

$MAX_POST_RETRIES = 20;
$MAX_CONNECT_RETRIES = 3;

echo(doPost("https://www.google.com/tbproxy/spell?hl=en&lang=$lang", $data));
break;

//           
case "ispell";
echo ispell($string, $lang);
break;
}

/**
 *                            
 *                            
 *                                                    
 */
function ispell($string, $lang) {
$lcode = getIspellLanguage($lang);
elog("echo " . escapeshellarg($string) . " | ispell -a -h -d $lcode 2>&1");
exec("echo " . escapeshellarg($string) . " | ispell -a -h -d $lcode 2>&1", $out);

//                                                   
$xml = '<?xml version="1.0" encoding="UTF-8"?>' . "\n";
$xml .= '<spellresult error="0" clipped="0" charschecked="' . strlen($string) . '">' . "\n";
while (list($i, $line) = each($out)) {
if (strpos($line, '&') === 0 && preg_match("/& (\w+) (\d+) (\d+): (.+)/", $line, $matches)) {
$word = $matches[1];
$offset = $matches[3];
$suggestions = $matches[4];
elog("$word: $suggestions");
$xml .= '	<c w="' . $word . '">' . $suggestions . '</c>' . "\n";
} else if (strpos($line, '#') === 0 && preg_match("/# (\w+) (\d+)/", $line, $matches)) {
//                                 
$word = $matches[1];
$offset = $matches[2];
elog("$word");
$xml .= '	<c w="' . $word . '"></c>' . "\n";
}
}
$xml .= "</spellresult>";
elog("");
return $xml;
}

/**
 *                                                                     
 *                                          
 *                                                                                                  
 */
function getIspellLanguage($lang) {
global $ISPELL_LANGUAGES;
if (array_key_exists($lang, $ISPELL_LANGUAGES)) {
return $ISPELL_LANGUAGES[$lang];
} else {
return 'default';
}
}

function elog($msg) {
error_log("$msg\n", 3, "/Node/tmp/spellcheck.log");
}

/**
 *                                               
 */
function doPost($url, $data, $retryNum=0) {
global $MAX_POST_RETRIES, $MAX_CONNECT_RETRIES;
$params = array(
'http' => array(
'method' => 'POST',
'content' => $data,
'timeout' => 10
)
);

$ctx = stream_context_create($params);

$retries = 0;
$fp = false;
while(!$fp) { 
$fp = @fopen($url, 'rb', false, $ctx);
elog("connecting - retry: $retries");
if ($fp || $retries == $MAX_CONNECT_RETRIES) {
break;
}
sleep(5);
$retries++;
}

elog("connected");

if (!$fp) {
elog("no file pointer");
/*                                                  
                                 /        */
return "Connection refused by Google Spellcheck Server";
}

$response = stream_get_contents($fp);

if ($response === false) {
elog("no response");
/*                                                  
                             /        */
return "No response from Google Spellcheck Server";
}

elog("received response");
if ($response == "" && $retryNum < $MAX_POST_RETRIES) {
//                                                 
//                                      
$retryNum += 1;
elog("response is empty: retry POST " . $retryNum);
sleep(1);
$response = doPost($url, $data, $retryNum);
}
return $response;
}
//                        
exit();
?>
